function dbg(text) {
	if (external==null) external = window.external;
	external.dbg(text);
}


//..汎用通信
var NET_MODE_RETRY = 0x01;
var net_mode;
var net_responsecode = 0;
var net_responsetext = "";
var net_successcallback, net_errorcallback, net_cancelcallback;
var net_url, net_params;
function cgi_param(url, reqhash, cb, errcb, cancelcb, mode) {
	net_successcallback = cb;
	net_errorcallback = errcb;
	net_cancelcallback = cancelcb;
	net_mode = mode;
	//通信開始
	net_url = url;
	net_params = reqhash;
	setTimeout(cgi_wait, 1);
}
function cgi_url(url, cb, errcb, cancelcb, mode) {
	net_successcallback = cb;
	net_errorcallback = errcb;
	net_cancelcallback = cancelcb;
	net_mode = mode;
	//通信開始
	net_url = url;
	net_params = null;
	setTimeout(cgi_wait, 1);
}
function cgi_wait() {
	cgi_exec(net_url, net_params);
}
function cgi_exec(url, param) {
	if (external==null) external = window.external;
	net_responsecode = 0;
	if (param==null) {
		var result = external.cgi_get(url);
		cgi_ajax_success(result);
	} else {
		var result = external.cgi_post(url, param);
		cgi_ajax_success(result);
	}
/*	try{
		$.ajax({
			type: (param==null)?"GET":"POST",
			url: url,
			data: param, 
			dataType: "text",
			error: cgi_ajax_error, 
			success: cgi_ajax_success, 
		});
		return;
	} catch(error) {
		//通信失敗
		net_responsetext = error;
	}*/
}
//通信失敗
function cgi_ajax_error(xmlHttp, textStatus, errorThrown) {
	net_responsetext = xmlHttp.responseText;	//アプリ側引渡し用
	net_responsecode = xmlHttp.status;
	//todo:ここでエラー表示 リトライ処理
	setTimeout(cgi_errorcb_exec, 10);
}
function cgi_errorcb_exec() {
	if (net_errorcallback!=null) net_errorcallback(net_responsetext);
}
//通信成功
function cgi_ajax_success(data, dataType) {
//console.log("success:"+data);
	net_responsetext = data;	//アプリ側引渡し用
	cgi_successcb_exec();
}
function cgi_successcb_exec() {
	if (net_successcallback!=null) {
		//成功の場合コールバック呼び出し
		var err = null;
		var tmp;
		try {
			tmp = JSON.parse(net_responsetext);
		} catch(e) {
			err = "exception:"+e+" "+net_responsetext;
		}
		if (!err) {
			if (tmp.status=="OK") {
				setTimeout(function(){
					net_successcallback(tmp.result);
				}, 0);
				return;
			} else if (tmp.status=="RETRY") {
				setTimeout(cgi_wait, 1000);
				return;
			} else {
				err = "status error:"+tmp.status;
			}
		}
		//console.log(err);
		if (net_errorcallback) net_errorcallback(err);
	}
}

//getパラメータ取得
function getUrlVars() {
	var vars = [], hash;
	var hashes = window.location.search.substring(1).split('&');
	for(var i = 0; i < hashes.length; i++) {
		hash = hashes[i].split('=');
		vars.push(hash[0]);
		vars[hash[0]] = hash[1];
	}
	return vars;
}
//
function html_escape(text) {
	return String(text)
		.replace(/&(?!\w+;)/g, '&amp;')
		.replace( /</g, "&lt;" )
		.replace( />/g, "&gt;" )
		.replace( /"/g, "&quot;" )
		.replace( /'/g, "&#39;" );
}

//日付フォーマット
function format02d(i) {
	//数字でも文字列でも可
	return ("00"+i).substr(-2);
}
function shortformatdate(dobj) {
	var i = dobj.getDay()
	var wt = "("+"日月火水木金土".substr(i,1)+")";
	return format02d(dobj.getMonth()+1)+"-"+format02d(dobj.getDate())+wt;
}
function formatdate(dobj) {
	var i = dobj.getDay()
	var wt = "("+"日月火水木金土".substr(i,1)+")";
	return format02d(dobj.getFullYear())+"-"+format02d(dobj.getMonth()+1)+"-"+format02d(dobj.getDate())+wt;
}
function formatdatetime(dobj) {
	var i = dobj.getDay()
	var wt = "("+"日月火水木金土".substr(i,1)+")";
	return format02d(dobj.getFullYear())+"-"+format02d(dobj.getMonth()+1)+"-"+format02d(dobj.getDate())+wt
	+" "+format02d(dobj.getHours())+":"+format02d(dobj.getMinutes())+":"+format02d(dobj.getSeconds());
}
function format04x(i) {
	//入力は数字のみ
	var tmp = (0x10000+i).toString(16);;
	return tmp.substr(-4);
}
function convert_json2date(text) {
	var num = text.match(/(\d+)-(\d+)-(\d+)T(\d+):(\d+):(\d+)Z/);
	var datetext = num[1]+"/"+num[2]+"/"+num[3]+" "+num[4]+":"+num[5]+":"+num[6];
	return new Date(datetext);
}
function date_to_text(text, duration) {
	//	StartTime: "2015-05-07T17:55:00Z"
	var num = text.match(/(\d+)-(\d+)-(\d+)T(\d+):(\d+):(\d+)Z/);
	var datetext = num[1]+"/"+num[2]+"/"+num[3]+" "+num[4]+":"+num[5]+":"+num[6];
	var dobj = new Date(datetext);
	var dow = dobj.getDay();
	if (duration==0) {
		return format02d(num[1])+"/"+num[2]+"/"+num[3]+"("+"日月火水木金土".substr(dow,1)+") "+num[4]+":"+num[5]+":"+num[6];
	}
	//終了時間
	dobj.setSeconds(dobj.getSeconds() + duration);
	var end = " ～ "+format02d(dobj.getHours())+":"+format02d(dobj.getMinutes())+":"+format02d(dobj.getSeconds());

	return format02d(num[1])+"/"+num[2]+"/"+num[3]+"("+"日月火水木金土".substr(dow,1)+") "+num[4]+":"+num[5]+":"+num[6] + end;
}
function title2(text) {
	//タイトルをファイル名にするときにフィルタを掛ける
	//return text.replace(/\[.+?\]/g, "");
	return text;
}
//
//C#用ダミー
/*var privateStorage = new function() {
	getItem = new function(key) {
		return window.external.getItem(key);
	}
	setItem = new function(key, value) {
		window.external.setItem(key, value);
	}
}*/
function MyClass(){}
MyClass.prototype = {
	getItem: function(key) {
		if (external==null) external = window.external;
		return external.getItem(key);
	},
	setItem: function(key, value){
		if (external==null) external = window.external;
		external.setItem(key, value);
	}
}
var privateStorage = new MyClass();

//window.privateStorage
var localstorage_version = "102";
function _localstorage_check() {
	var tmp = privateStorage.getItem("version");
	if (tmp==localstorage_version) return true;
	dbg("localStorageバージョンエラー:current="+tmp);
	return false;
}
function localstorage_check() {
	if (_localstorage_check()) return true;
	location.href = "/setting.html";
	return false;
}
function localstorage_set() {
	privateStorage.setItem("version", localstorage_version);
}

//ネイティブ側関数呼び出し
function native_setTitle(text) {
	if (external==null) external = window.external;
	external.setTitle(text);
}
function native_setMenuMode(type) {
	if (external==null) external = window.external;
	external.setMenuMode(type);
}
function native_openDetail(params) {
	if (external==null) external = window.external;
	external.open_detail(params);
}
function native_delete_cache(params) {
	if (external==null) external = window.external;
	external.delete_cache(params);
}
function native_open_timefree(params) {
	if (external==null) external = window.external;
	external.open_timefree(params);
}

//予約固有タグ
function _chk_tag(_array, tag) {
	//存在すればtrue
	for (var i = 0; i< _array.length; i++) {
		if (_array[i].Tag && _array[i].Tag==tag) {
			return true;
		}
	}
	return false;
	//return (grpid in condition);
}
function _new_tag(_array) {
	while(true) {
		var newtag = Math.random().toString(36).slice(-8);
		if (!_chk_tag(_array, newtag)) return newtag;
	}
}
